Subject: Re: [PATCH] Software receive packet steering

From: Ben Hutchings <[email-masked]>
Date: Thu, 09 Apr 2009 19:23:32 +0100

On Thu, 2009-04-09 at 09:43 -0700, Tom Herbert wrote:
> >>> -extern int          netif_receive_skb(struct sk_buff *skb);
> >>> +extern int            __netif_receive_skb(struct sk_buff *skb);
> >>> +
> >>> +static inline int netif_receive_skb(struct sk_buff *skb)
> >>> +{
> >>> +#ifdef CONFIG_NET_SOFTRPS
> >>> +    return netif_rx(skb);
> >>> +#else
> >>> +    return __netif_receive_skb(skb);
> >>> +#endif
> >>> +}
> >>
> >> Ugh, this forces all devices receiving back into a single backlog
> >> queue.
> >
> > Yes, it basically turns off NAPI.
> >
> 
> NAPI is still useful, but it does take a higher packet load before
> polling kicks in.  I believe this is similarly true for HW multi
> queue, and could actually be worse depending on the number of queues
> traffic is being split across (in my bnx2x experiment 16 core AMD with
> 16 queues, I was seeing around 300K interrupts per second, no benefit
> from NAPI).
[...]

Have you tried using fewer than 16 queues?  We found using every core in
a multi-core package to be a waste of cycles.

Ben.

-- 
Ben Hutchings, Senior Software Engineer, Solarflare Communications
Not speaking for my employer; that's the marketing department's job.
They asked us to note that Solarflare product names are trademarked.